unit u_animation_type;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs, FMX.Ani, FMX.Layouts,
  FMX.Memo, FMX.ListBox, FMX.Objects;

type
  TForm1 = class(TForm)
    initialize_: TButton;
    Memo1: TMemo;
    animate_: TButton;
    interpolation_listbox_: TListBox;
    animation_listbox_: TListBox;
    Rectangle1: TRectangle;
    FloatAnimation1: TFloatAnimation;
    FloatAnimation2: TFloatAnimation;
    Button1: TButton;
    return_: TButton;
    procedure initialize_Click(Sender: TObject);
    procedure animate_Click(Sender: TObject);
    procedure return_Click(Sender: TObject);
    procedure FloatAnimation1Process(Sender: TObject);
    procedure FormPaint(Sender: TObject; Canvas: TCanvas; const ARect: TRectF);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
  uses TypInfo;

{$R *.fmx}

    var g_step: Integer= 0;
        g_rectangle_path_data: TPathData= Nil;
        g_rectangle_position_array: array [0 .. 3000] of TPointF;
        g_saved_rectangle_position: TPointF;
        g_rectangle_position_index: Integer;

procedure display(p_text: String);
  begin
    Form1.Memo1.Lines.Add(p_text);
  end;

    function f_position: String;
      begin
        with Form1 do
//          Result:= Format('step %3d  position %5.0f', [g_step, Button1.Position.X]);
      end; // f_position

    function f_interpolation_type_name(p_interpolation_type: tInterpolationType): String;
      begin
        Result:= GetEnumName(TypeInfo(TInterpolationType), Integer(p_interpolation_type));
      end; // f_interpolation_type_name

    function f_animation_type_name(p_animation_type: tAnimationType): String;
      begin
        Result:= GetEnumName(TypeInfo(TanimationType), Integer(p_animation_type));
      end; // f_animation_type_name

    procedure TForm1.initialize_Click(Sender: TObject);
      var l_interpolation_type: tInterpolationType;
          l_animation_type: tAnimationType;
      begin
        // -- fill the interpolation type listbox
        for l_interpolation_type := Low(TInterpolationType) to High(TInterpolationType) do
          interpolation_listbox_.Items.AddObject(f_interpolation_type_name(l_interpolation_type),
              TObject(l_interpolation_type));
        interpolation_listbox_.ItemIndex := 0;

        for l_animation_type := Low(TanimationType) to High(TanimationType) do
          animation_listbox_.Items.AddObject(f_animation_type_name(l_animation_type),
              TObject(l_animation_type));
        animation_listbox_.ItemIndex := 0;

(*
        g_save_rectangle_x := Rectangle1.Position.X;
        g_save_rectangle_y := Rectangle1.Position.Y;
*)
        g_saved_rectangle_position.X := Rectangle1.Position.X;
        g_saved_rectangle_position.Y := Rectangle1.Position.Y;
(*

        Canvas.Stroke.Color := $FF0003F3;
        Canvas.Stroke.Kind:= tBrushKind.bkSolid;
*)
        g_rectangle_path_data := TPathData.Create;
        g_rectangle_path_data.MoveTo(g_saved_rectangle_position);
        g_rectangle_position_index := 0;
        g_rectangle_position_array[g_rectangle_position_index] := g_saved_rectangle_position;
(*
        Self.Fill.Kind:= tBrushKind.bkSolid;
        Self.Fill.Color := claSilver;
*)
        // Attach the FloatAnimations to the Rectangle's position
        with FloatAnimation1 do
        begin
          Parent := Rectangle1;
          PropertyName := 'Position.X';
          StartValue:= Rectangle1.Position.X;
          StopValue := Rectangle1.Position.X + 200;
          Duration := 1;
          AnimationType := tAnimationType.atIn;
          Interpolation := tInterpolationType.itLinear;
        end;

        with FloatAnimation2 do
        begin
          Parent := Rectangle1;
          PropertyName := 'Position.Y';
          StartValue:= Rectangle1.Position.Y;
          StopValue := Rectangle1.Position.Y - 200;
          Duration := 1;
          AnimationType := tAnimationType.atIn;
          Interpolation := tInterpolationType.itLinear;
        end;
      end; // initialize_Click

    procedure TForm1.animate_Click(Sender: TObject);
      var l_animation_type: TAnimationType;
          l_interpolation_type: TInterpolationType;
      begin
        with animation_listbox_ do
          l_animation_type := TAnimationType(Integer(Items.Objects[ItemIndex]));
        FloatAnimation2.AnimationType := l_animation_type;

        with interpolation_listbox_ do
          l_interpolation_type := TInterpolationType(Integer(Items.Objects[ItemIndex]));
        FloatAnimation2.Interpolation := l_interpolation_type;

        FloatAnimation1.Start;
        FloatAnimation2.Start;
      end; // move_Click

    procedure TForm1.return_Click(Sender: TObject);
      begin
        FloatAnimation1.Stop;
        FloatAnimation2.Stop;
      end; // return

    procedure TForm1.FloatAnimation1Process(Sender: TObject);
      var l_current_position: TPointF;
      begin
        if g_step mod 5= 0 then

        display(Format('%5.0f %5.0f', [Rectangle1.Position.X, Rectangle1.Position.Y]));
(*
        l_current_position.X := Rectangle1.Position.X;
        l_current_position.Y := Rectangle1.Position.Y;

        if (g_saved_rectangle_position.X <> l_current_position.X)
            OR (g_saved_rectangle_position.Y <> l_current_position.Y)
          then begin
              display(Format('save ', [l_current_position.X, l_current_position.Y]));
              g_rectangle_path_data.LineTo(l_current_position);
              g_rectangle_position_index := g_rectangle_position_index + 1;
              g_rectangle_position_array[g_rectangle_position_index] := l_current_position;
              g_saved_rectangle_position := l_current_position;

              Invalidate;
            end;
*)
      end; // FloatAnimation1Process

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_Click(Nil);
      end;

procedure TForm1.FormPaint(Sender: TObject; Canvas: TCanvas;
        const ARect: TRectF);
      var l_position_index: Integer;
      begin
(*
        for l_position_index := 0 to g_rectangle_position_index - 1 do
          Canvas.DrawLine(g_rectangle_position_array[l_position_index], g_rectangle_position_array[l_position_index + 1], 1.0);
*)
      end; // FormPaint

    end.

